/*
 * Copyright (C) 2017-2018 Yantra Cloud Ltd. <https://yantra.cloud>
 */

package cloud.yantra.patterns.actors.commands

import akka.actor.{Actor, ActorLogging, ActorRef, Props}
import akka.cluster.pubsub.DistributedPubSubMediator.{Publish, Subscribe}
import akka.cluster.pubsub.{DistributedPubSub, DistributedPubSubMediator}
import cloud.yantra.patterns.actors.entities.EntityPersistentActor
import cloud.yantra.patterns.actors.envelope.StationHeader
import cloud.yantra.patterns.actors.validations.CommandValidation
import cloud.yantra.patterns.actors.validations.CommandValidation.{CommandValidationInitiated, ValidateCommand, ValidationCompleted}
import cloud.yantra.patterns.cqrs.stages.DomainProcessingStage
import cloud.yantra.patterns.cqrs.{Command, Failed, Passed}

abstract class CommandProcessorManagerActor[Cmd <: Command]()
  extends Actor
    with ActorLogging {

  private type Topic = String

  /**
    * Capture the [[DistributedPubSub]] mediator for publishing events generated by [[EntityPersistentActor]].
    * Interested parties will consume this events and react to them.
    *
    * @return
    */
  def mediator(): ActorRef = DistributedPubSub(context.system).mediator

  /**
    * Topics to which the [[cloud.yantra.patterns.actors.entities.EntityManagerActor]] will publish
    * [[cloud.yantra.patterns.es.Event]].
    * The [[CommandProcessorManagerActor]] will listen for [[cloud.yantra.patterns.es.Event]] post processing of
    * validated [[Command]] by [[cloud.yantra.patterns.actors.entities.EntityManagerActor]].
    *
    * @return
    */
  def subscribeToEntityManagerEventTopics: Seq[Topic]


  /**
    * Topics from which the [[CommandProcessorManagerActor]] will listen for commands.
    *
    * @return
    */
  def subscribeToIncomingCommandTopics: Seq[Topic]


  /**
    * Topics to which the [[cloud.yantra.patterns.actors.entities.EntityManagerActor]] will listen for [[Command]].
    *
    * @return
    */
  def publishToEntityManagerCommandTopics: Seq[Topic]

  /**
    * Provides [[Props] related to [[cloud.yantra.patterns.actors.validations.TechnicalDomainCommandValidation]].
    *
    * @param command
    * @return
    */
  def technicalDomainValidationHandler(command: Cmd): Props

  /**
    * Provides [[Props]] related t0 [[cloud.yantra.patterns.actors.validations.BusinessDomainCommandValidation]].
    *
    * @param command
    * @return
    */
  def businessDomainValidationHandler(command: Cmd): Props

  override def preStart(): Unit = {
    // Subscribe to all topics, before getting ready for any processing.
    subscribeToIncomingCommandTopics.foreach { topic =>
      log.debug("Subscribing [{}] to command topic [{}] ", self.path, topic)
      mediator ! Subscribe(topic, self)
    }
    subscribeToEntityManagerEventTopics.foreach { topic =>
      log.debug("Subscribing [{}] to event topic [{}] ", self.path, topic)
      mediator ! Subscribe(topic, self)
    }
    super.preStart()
  }

  override def receive: Receive = processTechnicalValidation

  private def processTechnicalValidation: Receive = {
    case cmd: Cmd =>
      log.debug("Stage 1 : Initiating technical validation for command [{}]", cmd)
      val validator = context.actorOf(technicalDomainValidationHandler(cmd))
      validator ! ValidateCommand(cmd)

    case CommandValidationInitiated(validationId, DomainProcessingStage.TechnicalValidation, cmd) =>
      log.debug("Stage 1 : Technical validation initiated with validationId [{}] for command [{}]",
        validationId, cmd)

    case ValidationCompleted(validationId, DomainProcessingStage.TechnicalValidation, cmd, Passed) =>
      log.debug("Stage 1 : Technical validation completed with validationId [{}], command [{}] and result [{}]",
        validationId, cmd, Passed)
      sender ! CommandValidation.Stop
      //Initiate business validation
      self ! InitiateBusinessValidation(cmd.asInstanceOf[Cmd])

    case stage@ValidationCompleted(validationId, DomainProcessingStage.TechnicalValidation, cmd, failed: Failed) =>
      log.debug("Stage 1 : Technical validation completed with validationId [{}], command [{}] and result [{}]",
        validationId, cmd, failed)
      publishToCommandStations(stage)

    case InitiateBusinessValidation(cmd) =>
      log.debug("Stage 2 : Initiating business validation for command [{}]", cmd)
      val validator = context.actorOf(businessDomainValidationHandler(cmd))
      validator ! ValidateCommand(cmd)

    case CommandValidationInitiated(validationId, DomainProcessingStage.BusinessValidation, cmd) =>
      log.debug("Stage 2 : Business validation initiated with validationId [{}] for command [{}]",
        validationId, cmd)

    case ValidationCompleted(validationId, DomainProcessingStage.BusinessValidation, cmd, Passed) =>
      log.debug("Stage 2 : Business validation completed with validationId [{}], command [{}] and result [{}]",
        validationId, cmd, Passed)
      sender ! CommandValidation.Stop
      //Initiate business validation
      self ! InitiateDomainProcessing(cmd.asInstanceOf[Cmd])

    case stage@ValidationCompleted(validationId, DomainProcessingStage.BusinessValidation, cmd, failed: Failed) =>
      // Do something
      log.debug("Stage 2 : Business validation completed with validationId [{}], command [{}] and result [{}]",
        validationId, cmd, failed)
      publishToCommandStations(stage)

    case InitiateDomainProcessing(cmd) =>
      log.debug("Stage 3 : Initiating domain validation for command [{}]", cmd)
      publishToEntityManagerCommandTopics.foreach(topic => mediator ! Publish(topic, cmd))

    case DistributedPubSubMediator.SubscribeAck(subscribe) =>
      log.debug("Stage 0 : Subscription acknowledgement message received with data [{}]", subscribe)

    case unknown =>
      //Do nothing
      log.error("Received object of type [{}] can not used for processing by [{}]",
        unknown.getClass.getCanonicalName,
        this.getClass.getCanonicalName)

  }

  private def publishToCommandStations(stage: ValidationCompleted): Unit = {
    if (stage.command.isInstanceOf[StationHeader]) {
      stage.command.asInstanceOf[StationHeader].resultObservers.foreach { station =>
        log.debug("Publishing [{}] to command stations [{}] ", stage, station.path)
        station ! stage
      }
    }
  }

  /**
    * Message structure for internal private communications.
    *
    * @param cmd
    */
  private case class InitiateBusinessValidation(cmd: Cmd)

  private case class InitiateDomainProcessing(cmd: Cmd)

}
